#! /bin/bash

# 2020 by C. Masloch

# Usage of the works is permitted provided that this
# instrument is retained with the works, so that any entity
# that uses the works is notified of this instrument.
#
# DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_FREEDOS -D_RPL=0 -D_QUERY_GEOMETRY=0 -D_USE_PART_INFO=0 -D_CHS=1 -D_LBA=0 -o b12fdNNC.bin
nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_FREEDOS -D_RPL=0 -D_QUERY_GEOMETRY=1 -D_USE_PART_INFO=0 -D_CHS=1 -D_LBA=0 -o b12fdQNC.bin
nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_FREEDOS -D_RPL=0 -D_QUERY_GEOMETRY=0 -D_USE_PART_INFO=1 -D_CHS=1 -D_LBA=0 -o b12fdNUC.bin
nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_FREEDOS -D_RPL=0 -D_QUERY_GEOMETRY=1 -D_USE_PART_INFO=1 -D_CHS=1 -D_LBA=0 -o b12fdQUC.bin
nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_FREEDOS -D_RPL=0 -D_QUERY_GEOMETRY=0 -D_USE_PART_INFO=0 -D_CHS=0 -D_LBA=1 -o b12fdNNL.bin
nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_FREEDOS -D_RPL=0 -D_QUERY_GEOMETRY=0 -D_USE_PART_INFO=1 -D_CHS=0 -D_LBA=1 -o b12fdNUL.bin
nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_FREEDOS -D_RPL=0 -D_QUERY_GEOMETRY=0 -D_USE_PART_INFO=0 -D_CHS=1 -D_LBA=1 -o b12fdNNA.bin
nasm -f bin -DISFAT12 fdos/boot/boot.asm -o b12fdorg.bin
nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_LDOS -D_LOAD_NAME='"LDEBUG"' -D_QUERY_GEOMETRY=1 -D_USE_PART_INFO=1 -D_CHS=1 -D_LBA=1 -o b12debug.bin

nasm -f bin ldosboot/testpl.asm -I lmacros/ -o testpl.bin
nasm -f bin ldosboot/iniload.asm -I ldosboot/ -I scanptab/ -I lmacros/ -D_PAYLOAD_FILE='"testpl.bin"' -D_IMAGE_EXE -D_IMAGE_EXE_AUTO_STACK -D_IMAGE_EXE_MAX=0 -o testpl.com

for letters in NNC QNC NUC QUC NNL NUL NNA org
do
  nasm -D_PAYLOAD_FAT12="'b12fd$letters.bin'" -D_FAT12=1 -D_FAT16=0 -D_FAT32=0 instsect/instsect.asm -I ./ -I lmacros/ -o ifd12$letters.com
done
nasm -D_PAYLOAD_FAT12="'b12debug.bin'" -D_FAT12=1 -D_FAT16=0 -D_FAT32=0 instsect/instsect.asm -I ./ -I lmacros/ -o i12debug.com
