#! /bin/bash

# 2020 by C. Masloch

# Usage of the works is permitted provided that this
# instrument is retained with the works, so that any entity
# that uses the works is notified of this instrument.
#
# DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

if [ \! -d lmacros ]
then
  hg clone https://hg.ulukai.org/ecm/lmacros
else
  (cd lmacros && hg pull && hg up)
fi
if [ \! -d ldosboot ]
then
  hg clone https://hg.ulukai.org/ecm/ldosboot
else
  (cd ldosboot && hg pull && hg up)
fi
if [ \! -d scanptab ]
then
  hg clone https://hg.ulukai.org/ecm/scanptab
else
  (cd scanptab && hg pull && hg up)
fi
if [ \! -d instsect ]
then
  hg clone https://hg.ulukai.org/ecm/instsect
else
  (cd instsect && hg pull && hg up)
fi
if [ \! -d fdos ]
then
  git clone https://github.com/FDOS/kernel.git fdos
else
  (cd fdos && git pull --ff-only)
fi
